# coding: utf-8

"""
    Gitea API.

    This documentation describes the Gitea API.

    The version of the OpenAPI document: 1.19.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, StrictBool, StrictInt, StrictStr, conlist
from py_gitea_opensuse_org.models.payload_commit import PayloadCommit

class Branch(BaseModel):
    """
    Branch represents a repository branch
    """
    commit: Optional[PayloadCommit] = None
    effective_branch_protection_name: Optional[StrictStr] = None
    enable_status_check: Optional[StrictBool] = None
    name: Optional[StrictStr] = None
    protected: Optional[StrictBool] = None
    required_approvals: Optional[StrictInt] = None
    status_check_contexts: Optional[conlist(StrictStr)] = None
    user_can_merge: Optional[StrictBool] = None
    user_can_push: Optional[StrictBool] = None
    __properties = ["commit", "effective_branch_protection_name", "enable_status_check", "name", "protected", "required_approvals", "status_check_contexts", "user_can_merge", "user_can_push"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Branch:
        """Create an instance of Branch from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of commit
        if self.commit:
            _dict['commit'] = self.commit.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Branch:
        """Create an instance of Branch from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Branch.parse_obj(obj)

        _obj = Branch.parse_obj({
            "commit": PayloadCommit.from_dict(obj.get("commit")) if obj.get("commit") is not None else None,
            "effective_branch_protection_name": obj.get("effective_branch_protection_name"),
            "enable_status_check": obj.get("enable_status_check"),
            "name": obj.get("name"),
            "protected": obj.get("protected"),
            "required_approvals": obj.get("required_approvals"),
            "status_check_contexts": obj.get("status_check_contexts"),
            "user_can_merge": obj.get("user_can_merge"),
            "user_can_push": obj.get("user_can_push")
        })
        return _obj


